/*
   This program parses and then evaluates strings from Language-11.
*/

public class Examples
{
   public static void main(String[] args)
   {
      // Demonstrate a function parameter (using static scope).
      // (The final result should be 321. It would be 421 using dynamic scope.)
      String expr1 = "( prog " +
                       "( define w 300 ) " +
                       "( define f1 ( lambda x ( begin " +
                                              "( var f2 ( lambda y ( + ( + x y ) w ) ) ) " + // nested function
                                              "( apply f3 f2 ) ) ) ) " +  // nested function passed as a parameter
                       "( define f3 ( lambda z ( begin " +             // z is a function parameter
                                              "( var w 400 ) " +
                                              "( apply z 20 ) ) ) ) " +// call the function parameter
                       "( apply f1 1 ) )";


      // Show that function return values are not allowed.
      String expr2 = "( prog " +
                       "( define add " +
                           "( lambda  x " +
                                "( begin " +
                                  "( var r ( lambda y ( + x y ) ) ) " +  // r is a nested function
                                  "r ) ) ) " +                           // return the nested function
                       "( begin " +
                          "( var add2 ( apply add 2 ) ) " + // add returns a function
                          "( apply add2 3 ) ) )";           // call the returned function


      String expr = expr1;

      // build the abstract syntax tree that represents the expression
      Tree ast = BuildTree.buildTree( expr );

      // print the original expression
      System.out.println( expr + "\n" );
      // pretty-print the abstract syntax tree
      System.out.println( PrettyPrinter3.prettyPrint( ast ) + "\n" );
      // print the infix version of the expression
      System.out.println( AST2infix.ast2infix( ast ) + "\n" );

      try
      {
         // evaluate the expression (interpret the AST)
         Value value = Evaluate.evaluate( ast );

         System.out.println( "result = " + value );
      }
      catch (EvalException e)
      {
         e.printStackTrace();
      }
   }//main

}//Examples